from RoboidControl.Messages.Messages import IMessage

class ParticipantMsg(IMessage):
    """! A participant messages notifies other participants of its presence.

    When received by another participant, it can be followed by a NetworkIdMsg
    to announce that participant to this client such that it can join privately
    """
    ## The message ID
    id: int = 0xA0
    ## The length of the message
    length: int = 2

    def __init__(self, arg1):
        """! Create a new message for sending
        """
        if isinstance(arg1, bytes):
            buffer = arg1
            self.network_id = buffer[1]
        else:
            self.network_id = arg1

    def Serialize(self, buffer_ref):
        """! Serialize the message into a byte array. 
        @param buffer_ref The buffer to serialize into
        @return The length of the message in the buffer
        """
        if buffer_ref is None:
            return 0
        
        print(f'Send ParticipantMsg [{self.network_id}]')
        
        buffer: bytearray = buffer_ref[0]
        buffer[0:ParticipantMsg.length] = [
            ParticipantMsg.id,
            self.network_id
        ]
        return ParticipantMsg.length
